Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.hibernate4.support
Class OpenSessionInViewInterceptor

    java.lang.Object
      org.springframework.orm.hibernate4.support.OpenSessionInViewInterceptor

All Implemented Interfaces:
  WebRequestInterceptor

    public class OpenSessionInViewInterceptor

extends Object
implements WebRequestInterceptor

Spring web request interceptor that binds a Hibernate `Session` to the thread for the entire processing of the request.

This class is a concrete expression of the "Open Session in View" pattern, which is a pattern that allows for the lazy loading of associations in web views despite the original transactions already being completed.

This interceptor makes Hibernate Sessions available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `HibernateTransactionManager` as well as for non-transactional execution (if configured appropriately).

NOTE: This interceptor will by default not flush the Hibernate `Session`, with the flush mode being set to `FlushMode.NEVER`. It assumes that it will be used in combination with service layer transactions that handle the flushing: the active transaction manager will temporarily change the flush mode to `FlushMode.AUTO` during a read-write transaction, with the flush mode reset to `FlushMode.NEVER` at the end of each transaction. If you intend to use this interceptor without transactions, consider changing the default flush mode (through the `"flushMode"` property).

In contrast to `OpenSessionInViewFilter`, this interceptor is configured in a Spring application context and can thus take advantage of bean wiring..

WARNING: Applying this interceptor to existing logic can cause issues that have not appeared before, through the use of a single Hibernate `Session` for the processing of an entire request. In particular, the reassociation of persistent objects with a Hibernate `Session` has to occur at the very beginning of request processing, to avoid clashes with already loaded instances of the same objects.

Since:
  3.1
Author:
  Juergen Hoeller
See Also:
  `#setSingleSession`, `#setFlushMode`, `OpenSessionInViewFilter`, `HibernateTransactionManager`, `TransactionSynchronizationManager`

Field Summary
`protected Log` | `logger`
`static String` | `PARTICIPATE_SUFFIX` Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

Constructor Summary
`OpenSessionInViewInterceptor()`

Method Summary
`void` | `afterCompletion(WebRequest request, Exception ex)` Unbind the Hibernate `Session` from the thread and close it).
`protected String` | `getParticipateAttributeName()` Return the name of the request attribute that identifies that a request is already intercepted.
`SessionFactory` | `getSessionFactory()`
`protected Session` | `openSession()` Open a Session for the SessionFactory that this interceptor uses.
`void` | `postHandle(WebRequest request, ModelMap model)` Intercept the execution of a request handler after its successful invocation, right before view rendering (if any).
`void` | `preHandle(WebRequest request)` Open a new Hibernate `Session` according to the settings of this `HibernateAccessor` and bind it to the thread via the `TransactionSynchronizationManager`.
`void` | `setSessionFactory(SessionFactory sessionFactory)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PARTICIPATE_SUFFIX

    public static final String PARTICIPATE_SUFFIX

  Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

  See Also:
    `getParticipateAttributeName()`, Constant Field Values

### logger

    protected final Log logger

Constructor Detail

### OpenSessionInViewInterceptor

    public OpenSessionInViewInterceptor()

Method Detail

### setSessionFactory

    public void setSessionFactory(SessionFactory sessionFactory)

### getSessionFactory

    public SessionFactory getSessionFactory()

### preHandle

    public void preHandle(WebRequest request)
                   throws DataAccessException

  Open a new Hibernate `Session` according to the settings of this `HibernateAccessor` and bind it to the thread via the `TransactionSynchronizationManager`.

  Specified by:
    `preHandle` in interface `WebRequestInterceptor`
  Parameters:
    `request` - the current web request
  Throws:
    `DataAccessException`

### postHandle

    public void postHandle(WebRequest request,
                           ModelMap model)

  Description copied from interface: `WebRequestInterceptor`
  Intercept the execution of a request handler after its successful invocation, right before view rendering (if any).

  Allows for modifying context resources after successful handler execution (for example, flushing a Hibernate Session).

  Specified by:
    `postHandle` in interface `WebRequestInterceptor`
  Parameters:
    `request` - the current web request
    `model` - the map of model objects that will be exposed to the view (may be `null`). Can be used to analyze the exposed model and/or to add further model attributes, if desired.

### afterCompletion

    public void afterCompletion(WebRequest request,
                                Exception ex)
                         throws DataAccessException

  Unbind the Hibernate `Session` from the thread and close it).

  Specified by:
    `afterCompletion` in interface `WebRequestInterceptor`
  Parameters:
    `request` - the current web request
    `ex` - exception thrown on handler execution, if any
  Throws:
    `DataAccessException`
  See Also:
    `TransactionSynchronizationManager`

### openSession

    protected Session openSession()
                           throws DataAccessResourceFailureException

  Open a Session for the SessionFactory that this interceptor uses.

  The default implementation delegates to the `SessionFactory.openSession` method and sets the `Session`'s flush mode to "MANUAL".

  Returns:
    the Session to use
  Throws:
    `DataAccessResourceFailureException` - if the Session could not be created
  See Also:
    `FlushMode.MANUAL`

### getParticipateAttributeName

    protected String getParticipateAttributeName()

  Return the name of the request attribute that identifies that a request is already intercepted.

  The default implementation takes the `toString()` representation of the `SessionFactory` instance and appends `PARTICIPATE_SUFFIX`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD